#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include <math.h>
#include "timing.h"


int main(int argc, char *argv[])
{
#define OUTPUT 0
int N = atoi(argv[1]);
int nthreads = atoi(argv[2]);
unsigned long ticksB4, ticksAFT, ticks;
double freq = 2.5e9;

//double * __restrict__ a;
//double * __restrict__ b;
//double *__restrict__ c;

float *a,*b,*c,*d;
a = (float *) malloc(2*N * sizeof(float) );
b = (float *) malloc(2*N * sizeof(float) );
c = (float *) malloc(2*N * sizeof(float) );


srand(50);
for(int i=0; i<2*N; i++) {
	a[i] = (float) rand() / RAND_MAX;
	b[i] = (float) rand() / RAND_MAX;
	c[i] = 0.;
}

//c = a+2;

get_ticks(ticksB4);

for(int i=0; i<10000000; i++)
{
	for(int j=0;j<N;j++)
	{
//		c[j] += a[j] * b[j];
		a[j+2] += a[j] * b[j];
	}
}

get_ticks(ticksAFT);
ticks = ticksAFT - ticksB4;

printf("runtime without vectorization: %g\n\n", ticks/freq);


#if OUTPUT
printf("\nc:");
for(int i=0; i<N; i++) {
	printf(" %.3e", c[i]);
}
printf("\n\n");
#endif


srand(50);
for(int i=0; i<2*N; i++) {
	a[i] = (float) rand() / RAND_MAX;
	b[i] = (float) rand() / RAND_MAX;
//	c[i] = 0.;
}

get_ticks(ticksB4);

for(int i=0; i<10000000; i++)
{
#pragma omp simd
	for(int j=0;j<N;j++)
	{
//		c[j] += a[j] * b[j];
		a[j+2] += a[j] * b[j];
	}
}

get_ticks(ticksAFT);
ticks = ticksAFT - ticksB4;

printf("runtime with vectorization: %g\n\n", ticks/freq);

#if OUTPUT
printf("\nc:");
for(int i=0; i<N; i++) {
	printf(" %.3e", c[i]);
}
printf("\n\n");
#endif




return 0;
}
